#
# spec file for package ghc-set-cover
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global pkg_name set-cover
Name:           ghc-%{pkg_name}
Version:        0.0.9
Release:        lp150.4.2
Summary:        Solve exact set cover problems like Sudoku, 8 Queens, Soma Cube, Tetris Cube
License:        BSD-3-Clause
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
Source1:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/revision/1.cabal#/%{pkg_name}.cabal
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-enummapset-devel
BuildRequires:  ghc-psqueues-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-semigroups-devel
BuildRequires:  ghc-utility-ht-devel

%description
Solver for exact set cover problems. Included examples: Sudoku, Nonogram, 8
Queens, Domino tiling, Mastermind, Soma Cube, Tetris Cube, Cube of L's,
Logika's Baumeister puzzle. The generic algorithm allows to choose between slow
but flexible 'Set' from 'containers' package and fast but cumbersome
bitvectors.

For getting familiar with the package I propose to study the Queen8 example
along with "Math.SetCover.Exact".

Build examples with 'cabal install -fbuildExamples'.

The package needs only Haskell 98.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}
cp -p %{SOURCE1} %{pkg_name}.cabal

%build
%ghc_lib_build

%install
%ghc_lib_install

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files
%doc Changes.md

%changelog
* Tue Jul 10 2018 psimons@suse.com
- Add set-cover at version 0.0.9.
